local update_time = 2 -- number of seconds between wielditem updates

wield3d_rotation = {
	["default:torch"]=315,
	["default:sapling"]=315,
	["flowers:dandelion_white"]=315,
	["flowers:dandelion_yellow"]=315,
	["flowers:geranium"]=315,
	["flowers:rose"]=315,
	["flowers:tulip"]=315,
	["flowers:viola"]=315,
	["default:shovel_wood"]=270,
	["default:shovel_stone"]=270,
	["default:shovel_steel"]=270,
	["default:shovel_bronze"]=270,
	["default:shovel_mese"]=270,
	["default:shovel_diamond"]=270,
	["bucket:bucket_empty"]=270,
	["bucket:bucket_water"]=270,
	["bucket:bucket_lava"]=270,
	["screwdriver:screwdriver"]=270,
	["screwdriver:screwdriver1"]=270,
	["screwdriver:screwdriver2"]=270,
	["screwdriver:screwdriver3"]=270,
	["screwdriver:screwdriver4"]=270,
}

minetest.register_item("wield3d:hand", {
	type = "none",
	wield_image = "wield3d_trans.png",
})

minetest.register_entity("wield3d:wield_entity", {
	initial_properties = {
		physical = false,
		collisionbox = {x=0, y=0, z=0},
		visual = "wielditem",
		visual_size = {x=0.25, y=0.25},
	},
	wield_item = "",
	player = nil,
	timer = 0,
	on_step = function(self, dtime)
		local player = self.player
		if player == nil then 
			self.object:remove()
			return
		end
		self.timer = self.timer + dtime
		if self.timer < update_time then
			return
		end
		self.timer = 0
		if minetest.env:get_player_by_name(player:get_player_name()) == nil then 
			self.object:remove()
			return
		end		
		local stack = player:get_wielded_item()
		local item = stack:get_name()
		if item == self.wield_item then
			return
		end
		self.wield_item = item
		if item == "" then
			item = "wield3d:hand"
		end
		local rot = wield3d_rotation[item] or 0
		self.object:setpos(player:getpos())
		self.object:set_detach()
		self.object:set_attach(player, "Armature_Wield_Item", {x=0, y=0, z=0}, {x=0, y=0, z=rot})
		self.object:set_properties({textures={item}})
	end,
})

minetest.register_on_joinplayer(function(player)
	minetest.after(0.5, function(player)
		player:set_properties({
			visual = "mesh",
			mesh = "wield3d_character.x",
			visual_size = {x=1, y=1},
		})
		local pos = player:getpos()
		local entity = minetest.env:add_entity(pos, "wield3d:wield_entity")
		if entity ~= nil then
			entity:set_attach(player, "Armature_Wield_Item", {x=0, y=0, z=0}, {x=0, y=0, z=0})
			entity = entity:get_luaentity() 
			entity.player = player      
		end
	end, player)
end)

